<?php
namespace Claromentis\Infocapture\Subscriber;

$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5" . "36215"] = (@$GLOBALS["__65da1b1ec2d6653e8a0ab7848e5362" . "15"] ?: array()) + array("_d0407c814a49347e44aeaf3f7856" . "927f" => base64_decode("T25Vbm" . "xpa2U="), "_085a57daeaa7eb01c5adc" . "7d4956ca1ec" => base64_decode("T25" . "MaW" . "tl"), "aggre" . "gatio" . "n" => base64_decode("YWdncmVnYXRpb" . "24="), "_da9102682d361b8bbba479dd35a6a" . "5a6" => base64_decode("bGlrZV9jb3VudA=" . "="), "obje" . "ct_i" . "d" => base64_decode("b2JqZ" . "WN0X2" . "lk"));
use Claromentis\Core\Event\EventSubscriberInterface;
use Claromentis\Core\Event\GenericEvent;
use Claromentis\Core\Like\LikeEvents;
use Claromentis\Core\Like\LikesRepository;
use HDIssue;




class TicketLikeSubscriber implements EventSubscriberInterface
{
    
    
    
    
    private $likes_repo;
    
    
    
    
    private HDIssue $hd_issue;
    public function __construct(LikesRepository $_d9545fdd786c9a15186743b3fd0af9ff, HDIssue $_4ada5869286e9a58f9116abae0cfae31)
    {
        $this->likes_repo = $_d9545fdd786c9a15186743b3fd0af9ff;
        $this->hd_issue = $_4ada5869286e9a58f9116abae0cfae31;
    }
    public static function getSubscribedEvents() : array
    {
        return [LikeEvents::OBJECT_LIKED => $GLOBALS["__65da1b1ec2d6653e8a0ab" . "7848e536215"]["_085a57daea" . "a7eb01c5adc" . "7d4956ca1ec"], LikeEvents::OBJECT_UNLIKED => $GLOBALS["__65da1b1ec2d6653e8a0ab7848e536" . "215"]["_d0407c814a49347e44aeaf3f7856927" . "f"]];
    }
    public function OnLike(GenericEvent $event)
    {
        if (!$this->isIssueLikeEvent($event)) {
            return;
        }
        $_7c7f9b97a77342fe69e4b9ce8802e8d1 = $this->updateLikeCountProperty($event->getArgument($GLOBALS["__65da1b1ec2d6653e8" . "a0ab7848e536215"]["object_i" . "d"]));
    }
    public function OnUnlike(GenericEvent $event)
    {
        if (!$this->isIssueLikeEvent($event)) {
            return;
        }
        $_7c7f9b97a77342fe69e4b9ce8802e8d1 = $this->updateLikeCountProperty($event->getArgument($GLOBALS["__65da1b1ec2d6653e" . "8a0ab7848e536215"]["object_i" . "d"]));
    }
    
    
    
    
    
    private function updateLikeCountProperty(int $_39638557be821c8556d28efa25c94ff1) : bool
    {
        $_da9102682d361b8bbba479dd35a6a5a6 = $this->likes_repo->GetCount(AGGREGATION_IC_ISSUE, $_39638557be821c8556d28efa25c94ff1);
        $this->hd_issue->Load($_39638557be821c8556d28efa25c94ff1);
        $this->hd_issue->SetProperty($GLOBALS["__65da1b1ec2d6653e8a0a" . "b7848e536215"]["_da9102682d361b8bbba479dd35" . "a6a5a6"], $_da9102682d361b8bbba479dd35a6a5a6);
        return $this->hd_issue->Save();
    }
    
    
    
    
    
    private function isIssueLikeEvent(GenericEvent $event) : bool
    {
        return $event->hasArgument($GLOBALS["__65da1b1ec2" . "d6653e8a0ab7" . "848e536215"]["agg" . "reg" . "ati" . "on"]) && $event->getArgument($GLOBALS["__65da1b1ec2d" . "6653e8a0ab784" . "8e536215"]["aggrega" . "tion"]) === AGGREGATION_IC_ISSUE;
    }
}